> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/get-started/faq/save-load-custom-props.md).

# How to save and load a custom property on an annotation?

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

The recommended way is to use the [`setCustomData`](https://sdk.apryse.com/api/web/Core.Annotations.Annotation.html#setCustomData) function on annotations.

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
const myCustomAttributeValue = 'some custom data';
myAnnotation.setCustomData('myCustomAttribute', myCustomAttributeValue);
```

{% endcode %}
{% endtab %}
{% endtabs %}

When the PDF is downloaded this data will also be embedded inside the PDF and if you re-open the PDF in WebViewer it will be accessible through the [`getCustomData`](https://sdk.apryse.com/api/web/Core.Annotations.Annotation.html#getCustomData) function.

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
const myCustomAttributeValue = myAnnotation.getCustomData('myCustomAttribute');
```

{% endcode %}
{% endtab %}
{% endtabs %}

Alternatively you can use the [`setCustomSerializeHandler`](https://sdk.apryse.com/api/web/Core.Annotations.html#.setCustomSerializeHandler) and [`setCustomDeserializeHandler`](https://sdk.apryse.com/api/web/Core.Annotations.html#.setCustomDeserializeHandler) APIs, however note that saving an attribute this way will only work if you load XFDF separately from the PDF. If you download the PDF the attribute will not be preserved.

{% tabs %}
{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
const { Annotations } = instance.Core.Annotations;

Annotations.setCustomSerializeHandler(Annotations.Annotation, function(element, pageMatrix, options) {
  options.originalSerialize(element, pageMatrix);
  if (options.annotation.myCustomAttribute) {
    element.setAttribute('attribute-name', options.annotation.myCustomAttribute);
  }
  return element;
});

Annotations.setCustomDeserializeHandler(Annotations.Annotation, function(element, pageMatrix, options) {
  options.originalDeserialize(element, pageMatrix);
  options.annotation.myCustomAttribute = element.getAttribute('attribute-name');
});
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/web/get-started/faq/save-load-custom-props.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
